diff --git a/.travis.yml b/.travis.yml
index d750af1d..6bb08763 100644
--- a/.travis.yml
+++ b/.travis.yml
@@ -174,7 +174,7 @@ jobs:
                   install: true
                   script:
                           - ./bootstrap
-                          - ./configure --prefix=$HOME/odp-install $CROSS
+			  - ./configure --prefix=$HOME/odp-install $CROSS --enable-debug
                             --disable-test-cpp --enable-test-vald --enable-test-helper --enable-test-perf --enable-test-perf-proc --enable-test-example --with-cunit-path=$HOME/cunit-install/$CROSS_ARCH
                           - make -j $(nproc)
                 - stage: test
@@ -183,7 +183,7 @@ jobs:
                   install: true
                   script:
                           - ./bootstrap
-                          - ./configure --prefix=$HOME/odp/odp-install $CROSS
+			  - ./configure --prefix=$HOME/odp/odp-install $CROSS --enable-debug
                             --disable-test-cpp --enable-test-vald --enable-test-helper --enable-test-perf --enable-test-perf-proc --enable-test-example --with-cunit-path=$HOME/cunit-install/$CROSS_ARCH
                           - make -j $(nproc)
                 - stage: test
@@ -192,7 +192,7 @@ jobs:
                   install: true
                   script:
                           - ./bootstrap
-                          - ./configure --prefix=$HOME/odp-install $CROSS
+			  - ./configure --prefix=$HOME/odp-install $CROSS --enable-debug
                             --disable-test-cpp --enable-test-vald --enable-test-helper --enable-test-perf --enable-test-perf-proc --enable-test-example --with-cunit-path=$HOME/cunit-install/$CROSS_ARCH
                           - make -j $(nproc)
                 - stage: test
@@ -201,7 +201,7 @@ jobs:
                   install: true
                   script:
                           - ./bootstrap
-                          - ./configure --prefix=$HOME/odp-install $CROSS
+			  - ./configure --prefix=$HOME/odp-install $CROSS --enable-debug
                             --disable-test-cpp --enable-test-vald --enable-test-helper --enable-test-perf --enable-test-perf-proc --enable-test-example --with-cunit-path=$HOME/cunit-install/$CROSS_ARCH
                           - make -j $(nproc)
                 - stage: test
@@ -210,7 +210,7 @@ jobs:
                   install: true
                   script:
                           - ./bootstrap
-                          - ./configure --prefix=$HOME/odp-install $CROSS
+			  - ./configure --prefix=$HOME/odp-install $CROSS --enable-debug
                             --disable-test-cpp --enable-test-vald --enable-test-helper --enable-test-perf --enable-test-perf-proc --enable-test-example --with-cunit-path=$HOME/cunit-install/$CROSS_ARCH
                           - make -j $(nproc)
                 - stage: test
@@ -219,7 +219,7 @@ jobs:
                   install: true
                   script:
                           - ./bootstrap
-                          - ./configure --prefix=$HOME/odp-install $CROSS
+			  - ./configure --prefix=$HOME/odp-install $CROSS --enable-debug
                             --disable-test-cpp --enable-test-vald --enable-test-helper --enable-test-perf --enable-test-perf-proc --enable-test-example --with-cunit-path=$HOME/cunit-install/$CROSS_ARCH
                           - make -j $(nproc)
                 - stage: test
@@ -228,6 +228,7 @@ jobs:
                   script:
                           - ./bootstrap
                           - ./configure --prefix=$HOME/odp-install --enable-test-cpp --enable-test-vald --enable-test-helper --enable-test-perf --enable-user-guides --enable-test-perf-proc --enable-test-example --with-dpdk-path=`pwd`/dpdk/${TARGET} --with-netmap-path=`pwd`/netmap CFLAGS="-O0 -coverage" --with-cunit-path=$HOME/cunit-install/$CROSS_ARCH CXXFLAGS="-O0 -coverage" LDFLAGS="--coverage"
+			    --enable-debug
                           - sudo LD_LIBRARY_PATH="$HOME/cunit-install/$CROSS_ARCH/lib:$LD_LIBRARY_PATH" PATH=${PATH//:\.\/node_modules\/\.bin/} make check
                           - find . -type f -iname '*.[ch]' -not -path ".git/*" -execdir gcov {} \; ; bash <(curl -s https://codecov.io/bash) -X coveragepy
                 - stage: test