diff --git a/.travis.yml b/.travis.yml
index 245ade2a..478d4200 100644
--- a/.travis.yml
+++ b/.travis.yml
@@ -150,7 +150,17 @@ install:
 
 script:
         - ./bootstrap
-        - ./configure --prefix=$HOME/odp-install  --enable-test-cpp --enable-test-vald --enable-test-helper --enable-test-perf --enable-user-guides --enable-test-perf-proc --enable-test-example --with-dpdk-path=`pwd`/dpdk/${TARGET} --with-netmap-path=`pwd`/netmap --with-cunit-path=$HOME/cunit-install/$CROSS_ARCH $CONF
+        - ./configure --prefix=$HOME/odp-install
+          --enable-test-cpp
+          --enable-test-vald
+          --enable-test-helper
+          --enable-test-perf
+          --enable-user-guides
+          --enable-test-perf-proc
+          --enable-test-example
+          --with-dpdk-path=`pwd`/dpdk/${TARGET}
+          --with-netmap-path=`pwd`/netmap
+          --with-cunit-path=$HOME/cunit-install/$CROSS_ARCH $CONF
           --enable-debug
         - make -j $(nproc)
         - mkdir /dev/shm/odp
@@ -175,8 +185,15 @@ jobs:
                   install: true
                   script:
                           - ./bootstrap
-                          - ./configure --prefix=$HOME/odp-install $CROSS --enable-debug
-                            --disable-test-cpp --enable-test-vald --enable-test-helper --enable-test-perf --enable-test-perf-proc --enable-test-example --with-cunit-path=$HOME/cunit-install/$CROSS_ARCH
+                          - ./configure --prefix=$HOME/odp-install $CROSS
+                            --enable-debug
+                            --disable-test-cpp
+                            --enable-test-vald
+                            --enable-test-helper
+                            --enable-test-perf
+                            --enable-test-perf-proc
+                            --enable-test-example
+                            --with-cunit-path=$HOME/cunit-install/$CROSS_ARCH
                           - make -j $(nproc)
                 - stage: test
                   compiler: "\"clang-3.8 --target=aarch64-linux-gnu\""
@@ -184,8 +201,15 @@ jobs:
                   install: true
                   script:
                           - ./bootstrap
-                          - ./configure --prefix=$HOME/odp/odp-install $CROSS --enable-debug
-                            --disable-test-cpp --enable-test-vald --enable-test-helper --enable-test-perf --enable-test-perf-proc --enable-test-example --with-cunit-path=$HOME/cunit-install/$CROSS_ARCH
+                          - ./configure --prefix=$HOME/odp/odp-install $CROSS
+                            --enable-debug
+                            --disable-test-cpp
+                            --enable-test-vald
+                            --enable-test-helper
+                            --enable-test-perf
+                            --enable-test-perf-proc
+                            --enable-test-example
+                            --with-cunit-path=$HOME/cunit-install/$CROSS_ARCH
                           - make -j $(nproc)
                 - stage: test
                   compiler: arm-linux-gnueabihf-gcc
@@ -193,8 +217,15 @@ jobs:
                   install: true
                   script:
                           - ./bootstrap
-                          - ./configure --prefix=$HOME/odp-install $CROSS --enable-debug
-                            --disable-test-cpp --enable-test-vald --enable-test-helper --enable-test-perf --enable-test-perf-proc --enable-test-example --with-cunit-path=$HOME/cunit-install/$CROSS_ARCH
+                          - ./configure --prefix=$HOME/odp-install $CROSS
+                            --enable-debug
+                            --disable-test-cpp
+                            --enable-test-vald
+                            --enable-test-helper
+                            --enable-test-perf
+                            --enable-test-perf-proc
+                            --enable-test-example
+                            --with-cunit-path=$HOME/cunit-install/$CROSS_ARCH
                           - make -j $(nproc)
                 - stage: test
                   compiler: "\"clang-3.8 --target=arm-linux-gnueabihf\""
@@ -202,8 +233,15 @@ jobs:
                   install: true
                   script:
                           - ./bootstrap
-                          - ./configure --prefix=$HOME/odp-install $CROSS --enable-debug
-                            --disable-test-cpp --enable-test-vald --enable-test-helper --enable-test-perf --enable-test-perf-proc --enable-test-example --with-cunit-path=$HOME/cunit-install/$CROSS_ARCH
+                          - ./configure --prefix=$HOME/odp-install $CROSS
+                            --enable-debug
+                            --disable-test-cpp
+                            --enable-test-vald
+                            --enable-test-helper
+                            --enable-test-perf
+                            --enable-test-perf-proc
+                            --enable-test-example
+                            --with-cunit-path=$HOME/cunit-install/$CROSS_ARCH
                           - make -j $(nproc)
                 - stage: test
                   compiler: powerpc-linux-gnu-gcc
@@ -211,8 +249,15 @@ jobs:
                   install: true
                   script:
                           - ./bootstrap
-                          - ./configure --prefix=$HOME/odp-install $CROSS --enable-debug
-                            --disable-test-cpp --enable-test-vald --enable-test-helper --enable-test-perf --enable-test-perf-proc --enable-test-example --with-cunit-path=$HOME/cunit-install/$CROSS_ARCH
+                          - ./configure --prefix=$HOME/odp-install $CROSS
+                            --enable-debug
+                            --disable-test-cpp
+                            --enable-test-vald
+                            --enable-test-helper
+                            --enable-test-perf
+                            --enable-test-perf-proc
+                            --enable-test-example
+                            --with-cunit-path=$HOME/cunit-install/$CROSS_ARCH
                           - make -j $(nproc)
                 - stage: test
                   compiler: "\"clang-3.8 --target=powerpc-linux-gnu\""
@@ -220,15 +265,34 @@ jobs:
                   install: true
                   script:
                           - ./bootstrap
-                          - ./configure --prefix=$HOME/odp-install $CROSS --enable-debug
-                            --disable-test-cpp --enable-test-vald --enable-test-helper --enable-test-perf --enable-test-perf-proc --enable-test-example --with-cunit-path=$HOME/cunit-install/$CROSS_ARCH
+                          - ./configure --prefix=$HOME/odp-install $CROSS
+                            --enable-debug
+                            --disable-test-cpp
+                            --enable-test-vald
+                            --enable-test-helper
+                            --enable-test-perf
+                            --enable-test-perf-proc
+                            --enable-test-example
+                            --with-cunit-path=$HOME/cunit-install/$CROSS_ARCH
                           - make -j $(nproc)
                 - stage: test
                   env: TEST=coverage
                   compiler: gcc
                   script:
                           - ./bootstrap
-                          - ./configure --prefix=$HOME/odp-install --enable-test-cpp --enable-test-vald --enable-test-helper --enable-test-perf --enable-user-guides --enable-test-perf-proc --enable-test-example --with-dpdk-path=`pwd`/dpdk/${TARGET} --with-netmap-path=`pwd`/netmap CFLAGS="-O0 -coverage" --with-cunit-path=$HOME/cunit-install/$CROSS_ARCH CXXFLAGS="-O0 -coverage" LDFLAGS="--coverage"
+                          - ./configure --prefix=$HOME/odp-install
+                            --enable-test-cpp
+                            --enable-test-vald
+                            --enable-test-helper
+                            --enable-test-perf
+                            --enable-user-guides
+                            --enable-test-perf-proc
+                            --enable-test-example
+                            --with-dpdk-path=`pwd`/dpdk/${TARGET}
+                            --with-netmap-path=`pwd`/netmap CFLAGS="-O0
+                              -coverage"
+                            --with-cunit-path=$HOME/cunit-install/$CROSS_ARCH
+                              CXXFLAGS="-O0 -coverage" LDFLAGS="--coverage"
                             --enable-debug
                           - sudo LD_LIBRARY_PATH="$HOME/cunit-install/$CROSS_ARCH/lib:$LD_LIBRARY_PATH" PATH=${PATH//:\.\/node_modules\/\.bin/} make check
                           - find . -type f -iname '*.[ch]' -not -path ".git/*" -execdir gcov {} \; ; bash <(curl -s https://codecov.io/bash) -X coveragepy
@@ -237,7 +301,15 @@ jobs:
                   compiler: gcc
                   script:
                           - ./bootstrap
-                          - ./configure --prefix=$HOME/odp-install --enable-test-cpp --enable-test-vald --enable-test-helper --enable-test-perf --enable-user-guides --enable-test-perf-proc --enable-test-example --with-cunit-path=$HOME/cunit-install/$CROSS_ARCH
+                          - ./configure --prefix=$HOME/odp-install
+                            --enable-test-cpp
+                            --enable-test-vald
+                            --enable-test-helper
+                            --enable-test-perf
+                            --enable-user-guides
+                            --enable-test-perf-proc
+                            --enable-test-example
+                            --with-cunit-path=$HOME/cunit-install/$CROSS_ARCH
                           - sudo PATH="$PATH" LD_LIBRARY_PATH="$HOME/cunit-install/$CROSS_ARCH/lib:$LD_LIBRARY_PATH" make distcheck DISTCHECK_CONFIGURE_FLAGS="--with-cunit-path=$HOME/cunit-install/$CROSS_ARCH"
                 - stage: test
                   env: TEST=doxygen