diff --git a/.travis.yml b/.travis.yml
index d1520aa1a..54586fa57 100644
--- a/.travis.yml
+++ b/.travis.yml
@@ -75,10 +75,10 @@ compiler:
 install:
         - sudo apt-get install linux-headers-`uname -r`
 script:
-        - if [ "${CC#clang}" != "${CC}" ] ; then LD="" CXX=clang++; fi
+        - if [ "${CC#clang}" != "${CC}" ] ; then CXX=clang++; fi
         - if [ -n "${CROSS_ARCH}" ] ; then
                docker run  -i -t -v `pwd`:/odp
-                 -e CC="${CC}" -e LD="${LD}" -e CXX="${CXX}"
+                 -e CC="${CC}" -e CXX="${CXX}"
                  -e CONF="${CONF}" -e DPDK_SHARED="${DPDK_SHARED}"
                  ${DOCKER_NAMESPACE}/travis-odp-lng-ubuntu_14.04.05 /odp/scripts/ci/build_${CROSS_ARCH}.sh ;
           else
@@ -94,7 +94,7 @@ script:
                echo "Running test" ;
                docker run --privileged -i -t
                  -v `pwd`:/odp --shm-size 8g
-                 -e CC="${CC}" -e LD="${LD}" -e CXX="${CXX}"
+                 -e CC="${CC}" -e CXX="${CXX}"
                  -e CONF="${CONF}" -e DPDK_SHARED="${DPDK_SHARED}"
                  ${DOCKER_NAMESPACE}/travis-odp-lng-x86 /odp/scripts/ci/build_x86_64.sh ;
           fi
@@ -107,7 +107,7 @@ jobs:
                           - docker run --privileged -i -t
                               -v `pwd`:/odp --shm-size 8g
                               -e CODECOV_TOKEN="${CODECOV_TOKEN}"
-                              -e CC="${CC}" -e LD="${LD}" -e CXX="${CXX}"
+                              -e CC="${CC}" -e CXX="${CXX}"
                               -e CONF="${CONF}"
                               ${DOCKER_NAMESPACE}/travis-odp-lng-x86 /odp/scripts/ci/coverage.sh
                 - stage: test
@@ -116,7 +116,7 @@ jobs:
                   script:
                           - docker run --privileged -i -t
                               -v `pwd`:/odp --shm-size 8g
-                              -e CC="${CC}" -e LD="${LD}" -e CXX="${CXX}"
+                              -e CC="${CC}" -e CXX="${CXX}"
                               -e CONF="${CONF}"
                               ${DOCKER_NAMESPACE}/travis-odp-lng-x86 /odp/scripts/ci/distcheck.sh
                 - stage: "build only"
@@ -176,7 +176,7 @@ jobs:
                   script:
                           - docker run --privileged -i -t
                               -v `pwd`:/odp
-                              -e CC="${CC}" -e LD="${LD}" -e CXX="${CXX}"
+                              -e CC="${CC}" -e CXX="${CXX}"
                               -e CONF="${CONF}"
                              ${DOCKER_NAMESPACE}/travis-odp-lng-ubuntu_14.04.05_i386 /odp/scripts/ci/build_${CROSS_ARCH}.sh ;
                 - stage: test
@@ -185,7 +185,7 @@ jobs:
                   script:
                           - docker run --privileged -i -t
                               -v `pwd`:/odp
-                              -e CC="${CC}" -e LD="${LD}" -e CXX="${CXX}"
+                              -e CC="${CC}" -e CXX="${CXX}"
                               -e CONF="${CONF}"
                               ${DOCKER_NAMESPACE}/travis-odp-lng-ubuntu_14.04.05_i386 /odp/scripts/ci/build_${CROSS_ARCH}.sh ;
                 - stage: test
@@ -212,7 +212,7 @@ jobs:
                   script:
                           - docker run --privileged -i -t
                               -v `pwd`:/odp
-                              -e CC="${CC}" -e LD="${LD}" -e CXX="${CXX}"
+                              -e CC="${CC}" -e CXX="${CXX}"
                               -e CONF="${CONF}"
                               ${DOCKER_NAMESPACE}/travis-odp-lng-ubuntu_14.04.05_i386 /odp/scripts/ci/build_${CROSS_ARCH}.sh ;
                 - stage: test
@@ -221,7 +221,7 @@ jobs:
                   script:
                           - docker run --privileged -i -t
                               -v `pwd`:/odp
-                              -e CC="${CC}" -e LD="${LD}" -e CXX="${CXX}"
+                              -e CC="${CC}" -e CXX="${CXX}"
                               -e CONF="${CONF}"
                               ${DOCKER_NAMESPACE}/travis-odp-lng-ubuntu_14.04.05_i386 /odp/scripts/ci/build_${CROSS_ARCH}.sh ;
                 - stage: test